# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# Provides/Requires filtering is different from rpm 4.9 onwards
%global rpm49 %(rpm --version | perl -p -e 's/^.* (\\d+)\\.(\\d+).*/sprintf("%d.%03d",$1,$2) ge 4.009 ? 1 : 0/e')

Name:		perl-JSON
Summary:	Parse and convert to JSON (JavaScript Object Notation)
Version:	2.90
Release:	1.%{__distinit}%{__distvers}
License:	GPL+ or Artistic
Group:		Development/Libraries
URL:		http://search.cpan.org/dist/JSON/
Source0:	http://search.cpan.org/CPAN/authors/id/M/MA/MAKAMAKA/JSON-%{version}.tar.gz 
BuildArch:	noarch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildRequires:	perl(base)
BuildRequires:	perl(Carp)
BuildRequires:	perl(CGI)
BuildRequires:	perl(constant)
BuildRequires:	perl(Data::Dumper)
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(HTTP::Daemon)
BuildRequires:	perl(JSON::XS) >= 2.27
BuildRequires:	perl(lib)
BuildRequires:	perl(LWP::UserAgent)
BuildRequires:	perl(Scalar::Util)
BuildRequires:	perl(Test::More)
BuildRequires:	perl(Test::Pod)
BuildRequires:	perl(Tie::IxHash)
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))

# Filter unwanted perl provides and requires (rpm 4.9 onwards)
%global __provides_exclude perl\\(JSON::(Backend::PP|backportPP::Boolean|Boolean)\\)
%global __requires_exclude perl\\(JSON::backportPP\\)

%description
This module converts between JSON (JavaScript Object Notation) and Perl
data structure into each other. For JSON, see http://www.crockford.com/JSON/.

%prep
%setup -q -n JSON-%{version}

# Make rpmlint happy...
find ./ -type f -exec chmod -c -x {} \;
find t/ -type f -exec perl -pi -e 's|^#! perl|#!/usr/bin/perl|' {} \;
sed -i -e 's/\r//' README t/*

# Kludge to filter unwanted perl provides and requires (prior to rpm 4.9)
%if ! %{rpm49}
%global private_provides /^perl(JSON::\\(Backend::PP\\|backportPP::Boolean\\|Boolean\\))/d
%global private_requires /^perl(JSON::backportPP)$/d
%global perl_reqfilt /bin/sh -c "%{__perl_requires} | sed -e '%{private_requires}'"
%define __perl_requires %{perl_reqfilt}
%global perl_provfilt /bin/sh -c "%{__perl_provides} | sed -e '%{private_provides}'"
%define __perl_provides %{perl_provfilt}
%endif

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} \;
%{_fixperms} %{buildroot}

%check
make test

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes README
%{perl_vendorlib}/JSON.pm
%{perl_vendorlib}/JSON/
%{_mandir}/man3/JSON.3pm*
%{_mandir}/man3/JSON::backportPP.3pm*
%{_mandir}/man3/JSON::backportPP::Boolean.3pm*
%{_mandir}/man3/JSON::backportPP::Compat5005.3pm*
%{_mandir}/man3/JSON::backportPP::Compat5006.3pm*

%changelog
* Thu Oct 31 2013 Paul Howarth <paul@city-fan.org> 2.90-1
- Update to 2.90
  - INCOMPATIBLE CHANGE (JSON version 2.90)
  - JSON.pm used to patch JSON::XS::Boolean and JSON::PP::Boolean internally at
    loading time to make these modules inherit JSON::Boolean. However, since
    JSON::XS v3.0, it use Types::Serialiser as boolean class, which breaks
    the boolean class overload features and -support_by_pp if JSON::XS v3.0 or
    later is installed.
  - JSON::true and JSON::false returned JSON::Boolean objects. As a workaround,
    they return JSON::PP::Boolean objects in this version:
    isa_ok( JSON::true, 'JSON::PP::Boolean' );
  - It also discards a feature:
    ok( JSON::true eq 'true' );
  - In other words, JSON::PP::Boolean overloads numeric only:
    ok( JSON::true == 1 );

* Fri Oct 18 2013 Paul Howarth <paul@city-fan.org> 2.61-1
- Update to 2.61
  - $json->is_xs, $json->is_pp was completely broken (CPAN RT#75867)
  - Fixed return/or in _incr_parse (CPAN RT#86948)

* Wed Jul 17 2013 Paul Howarth <paul@city-fan.org> 2.59-2
- Perl 5.18 rebuild

* Wed Jun 12 2013 Paul Howarth <paul@city-fan.org> 2.59-1
- Update to 2.59
  - PUREPERL_ONLY support was not supported...  and finally remove all PP
    options from Makefile.PL
  - Recommend JSON::XS instead of conditionally requiring it
    (for example, $ cpanm --with-recommends JSON)
  - Hide more packages from PAUSE (and other stuff)
- Tweak provides filter not to filter as much

* Thu May 23 2013 Paul Howarth <paul@city-fan.org> 2.58-1
- Update to 2.58
  - Support PUREPERL_ONLY install option (CPAN RT#84876)
    (PERL_ONLY and NO_XS are not yet removed)
  - Stop installing JSON::XS automatically on Perl 5.18

* Sat Apr  6 2013 Paul Howarth <paul@city-fan.org> 2.57-1
- Update to 2.57
  - Fix t/x17_strange_overload.t (CPAN RT#84451)

* Fri Apr  5 2013 Paul Howarth <paul@city-fan.org> 2.55-1
- Update to 2.55
  - Fixed t/19_incr.t on perl ≥ 5.17.10 (CPAN RT#84154)
  - Fixed some spelling
  - Enhanced documents
  - Changed backend module loading for overloaded object behavior
  - Updated JSON::BackportPP version
- BR: perl(JSON::XS) for the test suite

* Mon Jun 25 2012 Paul Howarth <paul@city-fan.org> 2.53-5
- BR: perl(base), perl(Carp), perl(constant), perl(Data::Dumper) and perl(lib)
- Install to vendor directories
- Don't need to remove empty directories from the buildroot
- Drop support for old distributions prior to FC-3:
  - Don't need to define %%{perl_vendorlib}
  - Use DESTDIR rather than PERL_INSTALL_ROOT

* Tue Jun 28 2011 Paul Howarth <paul@city-fan.org> 2.53-2
- rebuild for perl 5.14.1 in Rawhide
- fix dist tag for CentOS 6 and Scientific Linux

* Sun May 22 2011 Paul Howarth <paul@city-fan.org> 2.53-1
- update to 2.53
  - fixed to_json (CPAN RT#68359)
  - backport JSON::PP 2.27200 (fixed incr_parse decoding string more correctly
    - CPAN RT#68032)
  - made Makefile.PL skip an installing XS question when set $ENV{PERL_ONLY} or
    $ENV{NO_XS} (CPAN RT#66820)
- nobody else likes macros for commands

* Tue Mar  8 2011 Paul Howarth <paul@city-fan.org> 2.51-1
- update to 2.51 (#683052)
  - import JSON::PP 2.27105 as BackportPP
  - fix documentation (CPAN RT#64738)
- use rpm 4.9 native filtering mechanism

* Thu Jan 27 2011 Paul Howarth <paul@city-fan.org> 2.50-2
- import from Fedora

* Thu Jan 27 2011 Paul Howarth <paul@city-fan.org> 2.50-1
- update to 2.50 (#665621)
  - JSON::PP split off into separate distribution and replaced with
    JSON::backportPP instead for internal use
- BR: perl(Test::Pod)
- drop t/ from %%doc as the tests are in the -tests subpackage
- filter private module perl(JSON::backportPP) from requires
- filter private module perl(JSON::backportPP::Boolean) from provides
- filter private module perl(JSON::Backend::PP) from provides
- filter private module perl(JSON::Boolean) from provides
- filter private module perl(JSON::PP) from provides (really JSON::backportPP)
- filter private module perl(JSON::PP::IncrParser) from provides

* Sun Nov 21 2010 Iain Arnell <iarnell@gmail.com> 2.27-1
- update to latest upstream version
- clean up spec for modern rpmbuild

* Sun May 02 2010 Marcela Maslanova <mmaslano@redhat.com> - 2.17-2
- mass rebuild with perl 5.12.0

* Sun Feb 28 2010 Chris Weyl <cweyl@alumni.drew.edu> 2.17-1
- update by Fedora::App::MaintainerTools 0.004
- PERL_INSTALL_ROOT => DESTDIR
- dropped old BR on perl(HTTP::Request)
- dropped old BR on perl(HTTP::Response)
- dropped old requires on perl(HTTP::Daemon)
- dropped old requires on perl(LWP::UserAgent)
- dropped old requires on perl(Scalar::Util)

* Wed Sep 02 2009 Chris Weyl <cweyl@alumni.drew.edu> 2.15-5
- adjust filtering so we don't drop the versioned perl(JSON:PP) prov

* Tue Sep 01 2009 Chris Weyl <cweyl@alumni.drew.edu> 2.15-4
- bump

* Mon Aug 31 2009 Chris Weyl <cweyl@alumni.drew.edu> 2.15-3
- update filtering 

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.15-2
- rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Mon Jun 22 2009 Chris Weyl <cweyl@alumni.drew.edu> 2.15-1
- auto-update to 2.15 (by cpan-spec-update 0.01)

* Sun Mar 01 2009 Chris Weyl <cweyl@alumni.drew.edu> 2.14-1
- update to 2.14

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.12-3
- rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.12-2
- rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Sun Oct 12 2008 Chris Weyl <cweyl@alumni.drew.edu> 2.12-1
- update to 2.12

* Wed Jun 25 2008 Chris Weyl <cweyl@alumni.drew.edu> 2.11-1
- update to 2.11

* Wed May 28 2008 Chris Weyl <cweyl@alumni.drew.edu> 2.09-1
- update to 2.09

* Sun Mar 09 2008 Chris Weyl <cweyl@alumni.drew.edu> 2.07-1
- update to 2.x series before F9

* Wed Mar  5 2008 Tom "spot" Callaway <tcallawa@redhat.com> 1.15-2
- rebuild for new perl

* Mon Nov 26 2007 Chris Weyl <cweyl@alumni.drew.edu> 1.15-1
- update to 1.15

* Sun May 13 2007 Chris Weyl <cweyl@alumni.drew.edu> 1.14-1
- update to 1.14

* Wed May 09 2007 Chris Weyl <cweyl@alumni.drew.edu> 1.13-1
- update to 1.13

* Fri May 04 2007 Chris Weyl <cweyl@alumni.drew.edu> 1.12-1
- update to 1.12
- add t/ to %%doc

* Wed Apr 25 2007 Chris Weyl <cweyl@alumni.drew.edu> 1.11-2
- bump

* Tue Apr 24 2007 Chris Weyl <cweyl@alumni.drew.edu> 1.11-1
- update to 1.11

* Wed Apr 18 2007 Chris Weyl <cweyl@alumni.drew.edu> 1.10-1
- specfile autogenerated by cpanspec 1.69.1
